> For the complete documentation index, see [llms.txt](https://docs.aios.foundation/aios-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.aios.foundation/aios-docs/aios-kernel/scheduler/rrscheduler.md).

# RRScheduler

### RRScheduler

The Round Robin scheduler ensures fair distribution of processing time among tasks by limiting each task's execution time and cycling through all tasks.

#### Key Features

* Configurable time slice per task (default: 1 second)
* Fair CPU time distribution
* Support for suspending and resuming long-running tasks
* Preemptive scheduling

#### Core Functions

```python
def _execute_syscall(self, syscall, executor, syscall_type):
    try:
        syscall.set_time_limit(self.time_slice)
        syscall.set_status("executing")
        self.logger.log(f"{syscall.agent_name} is executing {syscall_type} syscall.\n", "executing")
        syscall.set_start_time(time.time())

        response = executor(syscall)
        syscall.set_response(response)
        
        if response.finished:
            syscall.set_status("done")
            log_status = "done"
        else:
            syscall.set_status("suspending")
            log_status = "suspending"

        syscall.set_end_time(time.time())
        syscall.event.set()
        
        self.logger.log(
            f"{syscall_type} syscall for {syscall.agent_name} is {log_status}. Thread ID: {syscall.get_pid()}\n",
            log_status
        )
        
        return response
    # Error handling omitted for brevity
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.aios.foundation/aios-docs/aios-kernel/scheduler/rrscheduler.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
